@ECHO OFF

REM // make sure we can write to the file EHZ1.bin
REM // also make a backup to EHZ1.prev.bin
IF NOT EXIST EHZ1.bin goto LABLNOCOPY
IF EXIST EHZ1.prev.bin del EHZ1.prev.bin
IF EXIST EHZ1.prev.bin goto LABLNOCOPY
move /Y EHZ1.bin EHZ1.prev.bin
IF EXIST EHZ1.bin goto LABLERROR3
REM IF EXIST EHZ1.prev.bin copy /Y EHZ1.prev.bin EHZ1.bin
:LABLNOCOPY

REM // delete some intermediate assembler output just in case
IF EXIST EHZ1.p del EHZ1.p
IF EXIST EHZ1.p goto LABLERROR2
IF EXIST EHZ1.h del EHZ1.h
IF EXIST EHZ1.h goto LABLERROR1

REM // clear the output window
cls


REM // run the assembler
REM // -xx shows the most detailed error output
REM // -c outputs a shared file (EHZ1.h)
REM // -A gives us a small speedup
set AS_MSGPATH=win32/msg
set USEANSI=n

REM // allow the user to choose to print error messages out by supplying the -pe parameter
IF "%1"=="-pe" ( "win32/asw" -xx -c -A EHZ1.asm ) ELSE "win32/asw" -xx -c -E -A EHZ1.asm

REM // if there were errors, a log file is produced
IF EXIST EHZ1.log goto LABLERROR4

REM // combine the assembler output into a rom
IF EXIST EHZ1.p "win32/s2p2bin" EHZ1.p EHZ1.bin EHZ1.h


REM // done -- pause if we seem to have failed, then exit
IF NOT EXIST EHZ1.p goto LABLPAUSE
IF EXIST EHZ1.bin exit /b
:LABLPAUSE

pause


exit /b

:LABLERROR1
echo Failed to build because write access to EHZ1.h was denied.
pause


exit /b

:LABLERROR2
echo Failed to build because write access to EHZ1.p was denied.
pause


exit /b

:LABLERROR3
echo Failed to build because write access to EHZ1.bin was denied.
pause

exit /b

:LABLERROR4
REM // display a noticeable message
echo.
echo **********************************************************************
echo *                                                                    *
echo *   There were build errors/warnings. See EHZ1.log for more details.   *
echo *                                                                    *
echo **********************************************************************
echo.
pause


